def pick_two_obj_then_place(self, objecttype, receptacletype):
    def pick_two_obj_then_place():
        # we need pick two objects and place them, so here we define a recursive function
        if self.name2type(self.holding)!= self.name2type(objecttype):
            # Find the object
            entity = self.find_object(objecttype)
            if entity is None:
                # Find receptacletypes that can contain the object
                r_types = self.find_canbe_contained(objecttype)
                if r_types is None:
                    # Explore the environment
                    self.explore()
                    return
                else:
                    # Check each receptacletype to find the object
                    for r_type in r_types:
                        r_entitys = self.find_receptacles(r_type)
                        if r_entitys is None:
                            continue
                        for r_entity in r_entitys:
                            self.goto(r_entity.name)
                            if r_entity.openable and not r_entity.isopen:
                                self.open_receptacle(r_entity.name)
                                return
            else:
                # Go to the object's receptacle and take it
                if hasattr(self, "old_object_name") and self.old_object_name == entity.name:
                    # hasattr means that we have picked one object before, so we need to find another to pick
                    object_entitys = self.find_objects(objecttype)
                    if len(object_entitys) == 1:
                        self.explore() # if there is only one object, then explore the environment to find more objects
                        return
                    else:
                        pick_two_obj_then_place() # if there are more than one object, then pick_two_obj_then_place again
                        return
                self.goto(entity.in_on)
                r_entity = self.seen_entitys[entity.in_on]
                if r_entity.openable and not r_entity.isopen:
                    self.open_receptacle(r_entity.name)
                self.take(entity.name, entity.in_on)
                return
        else:
            # Find the receptacle to place the object
            r_entity = self.find_receptacle(receptacletype)
            if r_entity is None:
                # Explore the environment
                self.explore()
                return
            else:
                self.goto(r_entity.name)
                if r_entity.openable and not r_entity.isopen:
                    self.open_receptacle(r_entity.name)
                self.put(self.holding, r_entity.name)
                
                setattr(self, "old_object_name", self.holding)
                return
                
    pick_two_obj_then_place() # start the pick_two_obj_then_place process